;***************************************************************************************************************

;This software is provided in an AS IS condition,NO WARRANTIES in any form apply to this software.

; picmicrolab.com 6.1.2017
;***************************************************************************************************************
;Alphanumeric Display Driver PIC16F877A
;
;--------------------------------------------------------------------------------------------------------------	
		LIST 	P=PIC16F877A
		include	P16f877A.inc

 __CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_OFF & _HS_OSC & _LVP_OFF & _DEBUG_OFF & _CPD_OFF

	    org		0x00
reset:	goto start
	    org		0x04
start:

	bsf			STATUS, RP0
	bcf			STATUS, RP1
	movlw 		0x06;All PORTS are Digital
	movwf		ADCON1
	clrf		TRISC
	clrf		TRISD
	bsf			TRISA,0x00 ;LED Test
	bsf			TRISA,0x01 ;LATCH Input
	movlw		0xff;PORTB is Binary Input - 4 Digits
	movwf		TRISB
	;bsf			TRISB,0x05 ;LED Blanking
	;bsf			TRISC,0x07 ;LED Latch Input
	;movlw		0xff
	;movwf		TRISB;BCD Inputs
	bcf			STATUS, RP0
	movlw		0xff ;	Clear Display
	movwf		PORTC
	movwf		PORTD
;----------------------------------------------------
LOOP:
;-------------------Test if LED Blanking enabled RA2
btfsc	PORTA,0x02
goto	LEDTEST
movlw	0xff ;	Clear Display
movwf	PORTC
movlw	0xff ;	Clear Display
movwf	PORTD
goto	LOOP
;-----------------------------------------------------

LEDTEST:
;-------------------Test if LED Test enabled RB4
btfsc	PORTA,0x00 ;RA0 LED Test Input
goto	convert
movlw   0x00
movwf	PORTC
movwf	PORTD
;movwf 	0x40
;call    ConvertASCIItoAlphanumeric
goto	LEDTEST
;-----------------------------------------------------
convert:
movlw 0x0f;Isolate Lower 4 bits of PORTB
andwf PORTB,w
;movf PORTB,w
;-----If Latch Enabled send new value to display
btfss	PORTA,0x01
movwf 	0x40
call    ConvertASCIItoAlphanumeric 
;goto   	LOOP 
;movwf 0x40
;---------------------------------------------

goto   LOOP  

;------------------------------------
ConvertASCIItoAlphanumeric:
;------------------------------------
Digit1:
movf 0x40,w
sublw 0x01
btfss STATUS,Z ; 1
goto Digit2
movlw	0xf3
movwf	PORTC
movlw	0xFF
movwf	PORTD
return
;------------------------------------
Digit2:
movf 0x40,w
sublw 0x02
btfss STATUS,Z ; 2
goto Digit3
movlw	0x88
movwf	PORTC
movlw	0xFC
movwf	PORTD
return
;---------------------------
Digit3:
movf 0x40,w
sublw 0x03
btfss STATUS,Z ; 3
goto Digit4
movlw	0xC0
movwf	PORTC
movlw	0xFC
movwf	PORTD
return

;---------------------------
Digit4:
movf 0x40,w
sublw 0x04
btfss STATUS,Z ; 4
goto Digit5
movlw	0x73
movwf	PORTC
movlw	0xFC
movwf	PORTD
return
;---------------------------
Digit5:
movf 0x40,w
sublw 0x05
btfss STATUS,Z ; 5
goto Digit6
movlw	0x44
movwf	PORTC
movlw	0xFC
movwf	PORTD
return
;---------------------------
Digit6:
movf 0x40,w
sublw 0x06
btfss STATUS,Z ; 6
goto Digit7
movlw	0x04
movwf	PORTC
movlw	0xFC
movwf	PORTD
return
;---------------------------
Digit7:
movf 0x40,w
sublw 0x07
btfss STATUS,Z ; 7
goto Digit8
movlw	0xf0
movwf	PORTC
movlw	0xFF
movwf	PORTD
return
;----------------------------
Digit8:
movf 0x40,w
sublw 0x08
btfss STATUS,Z ; 8
goto Digit9
movlw	0x00
movwf	PORTC
movlw	0xFC
movwf	PORTD
return
;---------------------------
Digit9:
movf 0x40,w
sublw 0x09
btfss STATUS,Z ; 9
goto DigitA
movlw	0x40
movwf	PORTC
movlw	0xFC
movwf	PORTD
return
;---------------------------
DigitA:
movf 0x40,w
sublw 0x0A ;     A
btfss STATUS,Z ; 
goto DigitB
movlw	0x30
movwf	PORTC
movlw	0xFC
movwf	PORTD
return
;---------------------------
DigitB:
movf 0x40,w
sublw 0x0B ;     B
btfss STATUS,Z ; 
goto DigitC
movlw	0xC0
movwf	PORTC
movlw	0xB5
movwf	PORTD
return
;---------------------------
DigitC:
movf 0x40,w
sublw 0x0C ;     C
btfss STATUS,Z ; 
goto DigitD
movlw	0x0C
movwf	PORTC
movlw	0xFF
movwf	PORTD
return
;--------------------------

DigitD:
movf 0x40,w
sublw 0x0D ;     D
btfss STATUS,Z ; 
goto DigitE
movlw	0xC0
movwf	PORTC
movlw	0xB7
movwf	PORTD
return
;---------------------------
DigitE:
movf 0x40,w
sublw 0x0E ;     E
btfss STATUS,Z ; 
goto DigitF
movlw	0x0C
movwf	PORTC
movlw	0xFE
movwf	PORTD
return
;--------------------------
DigitF:
movf 0x40,w
sublw 0x0F ;     F
btfss STATUS,Z ; 
goto Digit0
movlw	0x3C
movwf	PORTC
movlw	0xFE
movwf	PORTD
return
;--------------------------
Digit0:
movf 0x40,w
btfss STATUS,Z ; 0
return
movlw	0x00
movwf	PORTC
return
;---------------------------

end